using UnityEngine;

namespace Mod
{
	public class Mod
	{
		public static void Main()
		{
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("PPSH"),
					NameOverride = "MAC-10",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Compact, blowback operated machine pistol",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/MAC-10-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var MacSlide = Instance.transform.Find("Slide");
                        MacSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/MacSlide2.png", 0.151f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/MAC-10.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "MAC 10 - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/MAC-10.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2900f, 0.1600f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.07f;
			}
                }
            );					
			
			ModAPI.Register(
                new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("PPSH"),
					NameOverride = "MAC-10 Suppressed",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Suppressed version of the MAC-10",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/MAC-10sup-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var MacSlide = Instance.transform.Find("Slide");
                        MacSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/MacSupSlide2.png", 0.151f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/MAC-10Suppressed.png", 2.5f);
						
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "MAC 10 - Cartridge";
						
						customCartridge.Damage *= 0.65f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.3f,0.2f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/MAC-10SUP.mp3"),
						
						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5000f, 0.1600f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.07f;
		    }
                }
            );	
						
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("PPSH"),
					NameOverride = "TEC-9",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Blowback-operated semi-automatic pistol. This one has been converted to full-auto",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/TEC9-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var TecSlide = Instance.transform.Find("Slide");
                        TecSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TecSlide2.png", 0.148f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TEC-9.png", 3f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "TEC 9 - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/TEC-9.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2800f, 0.1450f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.08f;						
							
            }
                }
            );
			
			ModAPI.Register(
                new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Pistol"),
					NameOverride = "Mini-UZI",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "A smaller version of the regular Uzi",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/UZI-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/UZI.png", 3f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "UZI - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.2f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/UZI.mp3"),
						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3700f, 0.1500f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.05f;
			 }
                }
             );
			
			ModAPI.Register(
                new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Pistol"),
					NameOverride = "Glock 18",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Full-auto Glock pistol",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Glock-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var GlockSlide = Instance.transform.Find("Slide");
                        GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/GLOCK-18Slide.png", 3.25f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/GLOCK-18.png", 3.25f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "GLOCK - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.2f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/GLOCK1.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2400f, 0.2200f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.065f;
		    }
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "Beretta M9",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic pistol designed and manufactured by Beretta of Italy",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/BerettaM9-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var M9Slide = Instance.transform.Find("Slide");
                        M9Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/BerettaM9Slide.png", 4f);
						M9Slide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/BerettaM9.png", 4f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "Beretta - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/BERETTA.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2400f, 0.1200f);
						
							
            }
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "FN Five-seveN",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic pistol named for its 5.7×28mm (.224 in) bullet diameter",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/FN57-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var FNSlide = Instance.transform.Find("Slide");
                        FNSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/FN-57Slide.png", 3.75f);
						FNSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/FN-57.png", 3.75f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "FN57 - Cartridge";
						
						customCartridge.Damage *= 0.85f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/FN57.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2200f, 0.1100f);
						
							
            }
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "AMT Hardballer Suppressed",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Names are for friends",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Silverballer-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var HardballerSlide = Instance.transform.Find("Slide");
                        HardballerSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/silverballerslide.png", 3.75f);
						HardballerSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/silverballer.png", 3.75f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "Silverballer - Cartridge";
						
						customCartridge.Damage *= 0.65f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.3f,0.1f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/SILVERBALLER.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3800f, 0.1100f);
            }
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "USP Compact",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic pistol developed in Germany by Heckler & Koch",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/USP-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var USPSlide = Instance.transform.Find("Slide");
                        USPSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/USPCompactSlide.png", 4f);
						USPSlide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/USPCompact.png", 4f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "USP - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/USPCOMPACT.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2200f, 0.1100f);
						
			}
                }
            );
						
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "M1911A1",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic, recoil-operated pistol chambered for the .45 ACP cartridge",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/M1911-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var M19Slide = Instance.transform.Find("Slide");
                        M19Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/m1911slide.png", 3.75f);
						M19Slide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/m1911.png", 3.75f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "M1911 - Cartridge";
						
						customCartridge.Damage *= 0.85f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/M1911.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2300f, 0.1200f);
            }
                }
            );
			
			ModAPI.Register(
                new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Pistol"),
					NameOverride = "Glock 17",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-Automatic Glock pistol",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Glock2-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var GlockSlide = Instance.transform.Find("Slide");
                        GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/GLOCK-17Slide.png", 3.25f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/GLOCK-17.png", 3.25f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						
						customCartridge.name = "GLOCK - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.2f);
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/GLOCK1.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2200f, 0.1300f);
		    }
                }
            );
			
			ModAPI.Register(
                new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Revolver"),
					NameOverride = "Taurus Model 44",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = ".44 caliber revolver manufactured by Brazilian arms company Taurus",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Taurus-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var BullHammer = Instance.transform.Find("hammer center").Find("pixel");
                        BullHammer.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/taurushammer.png", 0.1f);
						// Thank you unity docs
					    BullHammer.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
					    BullHammer.transform.localPosition = new Vector3(0.02f, 0f);
						BullHammer.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder - 1;
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/taurus.png", 3.75f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("38 Special");
						
						customCartridge.name = "Revolver - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.Cartridge = customCartridge;firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/TAURUS.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.2000f, 0.0700f);
		    }
                }
            );
        }
    }
}